//
//  ViewController.swift
//  MerchantAppSwift
//
//  Created by Mayur Shinde on 14/11/17.
//  Copyright © 2017 Avenues. All rights reserved.
//

import UIKit

class ViewController: UIViewController, InitialViewControllerDelegate, UITextFieldDelegate
{
    var initCont = InitialViewController()
    
    var showAdd = "N"
    var useCCPromo = "N"
    
    var validateAdd = "N"
    
    @IBOutlet weak var merchantIDTF: UITextField!
    @IBOutlet weak var acessCodeTF: UITextField!
    @IBOutlet weak var currencyTF: UITextField!
    @IBOutlet weak var amountTF: UITextField!
    @IBOutlet weak var custIDTF: UITextField!
    @IBOutlet weak var orderIDTF: UITextField!
    
    @IBOutlet weak var billingNameTF: UITextField!
    @IBOutlet weak var billingAddressTF: UITextField!
    @IBOutlet weak var billingCityTF: UITextField!
    @IBOutlet weak var billingStateTF: UITextField!
    @IBOutlet weak var billingCountryTF: UITextField!
    @IBOutlet weak var billingTelTF: UITextField!
    @IBOutlet weak var billingEmailTF: UITextField!
    
    @IBOutlet weak var shippingNameTF: UITextField!
    @IBOutlet weak var shippingAddressTF: UITextField!
    @IBOutlet weak var shippingCityTF: UITextField!
    @IBOutlet weak var shippingStateTF: UITextField!
    @IBOutlet weak var shippingCountry: UITextField!
    @IBOutlet weak var shippingTelTF: UITextField!
    
    @IBOutlet weak var rsaKeyURLTF: UITextField!
    @IBOutlet weak var redirectURLTF: UITextField!
    @IBOutlet weak var cancelURLTF: UITextField!
    
    @IBOutlet weak var showAddSwitch: UISwitch!
    @IBOutlet weak var useCCPromoSwitch: UISwitch!
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        merchantIDTF.delegate = self
        acessCodeTF.delegate = self
        currencyTF.delegate = self
        amountTF.delegate = self
        custIDTF.delegate = self
        
        billingNameTF.delegate = self
        billingAddressTF.delegate = self
        billingCityTF.delegate = self
        billingStateTF.delegate = self
        billingCountryTF.delegate = self
        billingTelTF.delegate = self
        billingEmailTF.delegate = self
        
        shippingNameTF.delegate = self
        shippingAddressTF.delegate = self
        shippingCityTF.delegate = self
        shippingStateTF.delegate = self
        shippingCountry.delegate = self
        shippingTelTF.delegate = self
        
        rsaKeyURLTF.delegate = self
        redirectURLTF.delegate = self
        cancelURLTF.delegate = self
        
        showAddSwitch.isOn = false
        useCCPromoSwitch.isOn = false
    }
    
    @IBAction func showAddSwitchChanged(_ sender: Any)
    {
        if (self.showAddSwitch.isOn == true)
        {
            showAdd = "Y";
        }
        else
        {
            showAdd = "N";
        }
    }
    
    @IBAction func useCCPromoSwitchChanged(_ sender: Any)
    {
        if (self.useCCPromoSwitch.isOn == true)
        {
            useCCPromo = "Y";
        }
        else
        {
            useCCPromo = "N";
        }
    }
    
    func getResponse(_ responseDict_: NSMutableDictionary!)
    {
        let orderNum = "\(responseDict_["order_id"] ?? "")"
        let orderStatus = "\(responseDict_["order_status"] ?? "")"
        let orderTrackId = "\(responseDict_["tracking_id"] ?? "")"

        let msg = "Your order # \(orderNum) is \(orderStatus)\n\nPayment Reference Number : \(orderTrackId)\n\nYou may use this number for any future communications.";
        
        let alert = UIAlertController(title: "Payment Status", message: msg, preferredStyle: UIAlertControllerStyle.alert)
        
        alert.addAction(UIAlertAction(title: "Done", style: UIAlertActionStyle.default, handler: nil));
        
        self.present(alert, animated: true, completion: nil);
    }
    
    @IBAction func payBtnClicked(_ sender: Any)
    {
    
        //let initCont = InitViewController.init(orderId: "\((arc4random() % 9999999) + 1)", merchantId: "79775", accessCode: "AVLP72EH75CG90PLGC", custId: "hemangi", amount: "1.00", currency: "INR", rsaKeyUrl: "https://secure.ccavenue.com/transaction/jsp/GetRSA.jsp", redirectUrl: "https://qasecure.ccavenue.com/transaction/appapi.do?command=responseHandlerJSON", cancelUrl: "https://qasecure.ccavenue.com/transaction/appapi.do?command=responseHandlerJSON", showAddress: "Y", validateAddress: "Y", billingName: "Mayur Shinde", billingAddress: "Avenues India Pvt. Ltd.", billingCity: "Mumbai", billingState: "Maharashtra", billingCountry: "INDIA", billingZipCode: "400054", billingTel: "7387387878", billingEmail: "mayur.shinde@avenues.info", deliveryName: "Ram Mhapasekar", deliveryAddress:
            //"CCAvenue India", deliveryCity: "Mumbai", deliveryState: "Maharashtra", deliveryCountry: "INDIA", deliveryZipCode: "400054", deliveryTel: "7875858787")
        
        //initCont = InitialViewController.init(orderId: "\((arc4random() % 9999999) + 1)", merchantId: merchantIDTF.text!, accessCode: acessCodeTF.text!, custId: custIDTF.text!, amount: amountTF.text!, currency: currencyTF.text!, rsaKeyUrl: rsaKeyURLTF.text!, redirectUrl: redirectURLTF.text!, cancelUrl: cancelURLTF.text!, showAddress: showAdd, billingName: billingNameTF.text!, billingAddress: billingAddressTF.text!, billingCity: billingCityTF.text!, billingState: billingStateTF.text!, billingCountry: billingCountryTF.text!, billingTel: billingTelTF.text!, billingEmail: billingEmailTF.text!, deliveryName: shippingNameTF.text!, deliveryAddress: shippingAddressTF.text!, deliveryCity: shippingCityTF.text!, deliveryState: shippingStateTF.text!, deliveryCountry: shippingCountry.text!, deliveryTel: shippingTelTF.text!, promoName:orderIDTF.text)
        
        initCont = InitialViewController.init(orderId: "\((arc4random() % 9999999) + 1)", merchantId: merchantIDTF.text!, accessCode: acessCodeTF.text!, custId: custIDTF.text!, amount: amountTF.text!, currency: currencyTF.text!, rsaKeyUrl: rsaKeyURLTF.text!, redirectUrl: redirectURLTF.text!, cancelUrl: cancelURLTF.text!, showAddress: showAdd, billingName: billingNameTF.text!, billingAddress: billingAddressTF.text!, billingCity: billingCityTF.text!, billingState: billingStateTF.text!, billingCountry: billingCountryTF.text!, billingTel: billingTelTF.text!, billingEmail: billingEmailTF.text!, deliveryName: shippingNameTF.text!, deliveryAddress: shippingAddressTF.text!, deliveryCity: shippingCityTF.text!, deliveryState: shippingStateTF.text!, deliveryCountry: shippingCountry.text!, deliveryTel: shippingTelTF.text!, promoCode: orderIDTF.text, merchant_param1: "Paramater 1", merchant_param2: "Paramater 2", merchant_param3: "Paramater 3", merchant_param4: "Paramater 4", merchant_param5: "Paramater 5", useCCPromo: useCCPromo)
        
        initCont.delegate = self;
        
        self.present(initCont, animated: true, completion: nil);
    }
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool
    {
        self.view.endEditing(true)
        return false
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
}

